<?php

class RoleManagement {
	protected $client;
	
	function __construct($server) {
		$sbWsdl = $server. '/RoleManagement?wsdl';
		$this->client = new SoapClient ( $sbWsdl );
	}
	
	public function findAllRoles() {
		$param = array ();
		$response = $this->client->__soapCall ( "findAllRoles", $param );
		return $this->objectToArray ( $response );
	}
	
	public function createRole($name, $description, $category) {
		
		$param = array (
				array (
						role => array (
								"name" => $name,
								"description" => $description,
								"category" => $category,
								"id" => "" 
						) 
				) 
		);
		return $this->client->__soapCall ( "createRole", $param );
	}
	
	public function updateRole($id, $name, $description, $category) {
		$param = array (
				array (
						role => array (
								"name" => $name,
								"description" => $description,
								"category" => $category,
								"id" => $id 
						) 
				) 
		);
		return $this->client->__soapCall ( "updateRole", $param );
	}
	
	public function deleteRole($id) {
		$param = array (
				array (
						"roleId" => $id 
				) 
		);
		return $this->client->__soapCall ( "deleteRole", $param );
	}
	
	public function findRolesByProject($id) {
		$param = array (
				array (
						"projectId" => $id 
				) 
		);
		$response = $this->client->__soapCall ( "findRolesByProject", $param );
		return $this->objectToArray ( $response );
	}
	
	public function findRolesByProjectAndParticipant($projectId, $participantId) {
		$param = array (
				array (
						"projectId" => $projectId,
						"participantId" => $participantId
				) 
		);
		$response = $this->client->__soapCall ( "findRolesByProjectAndParticipant", $param );
		return $this->objectToArray ( $response );
	}
	
	public function objectToArray($d) {
		
		if (is_object ( $d )) {
			// Gets the properties of the given object
			// with get_object_vars function
			$d = get_object_vars ( $d );
		}
		
		if (count ( $d ) > 0) {
			foreach ( $d as $val ) {
				if (is_array ( $val )) {
					return $val;
				}
			
			}
			return $d;
		}
	}
}
?>