package org.galaxy.client.service.fragmentmanagement.ressource;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.galaxy.client.service.fragmentmanagement.ModelFragmentData;


public class ModelFragmentRessource extends ModelFragmentData{

    private File xmiFile = null;    

    private List<RessourceFile> resFiles = new ArrayList<RessourceFile>();

    private List<ProprietaryFile> propFiles = new ArrayList<ProprietaryFile>();

    public ModelFragmentRessource(){
    }


    public ModelFragmentRessource(
            org.galaxy.client.service.fragmentmanagement.ModelFragmentData[] dependencies,
            java.lang.String description,
            java.lang.String galaxyId,
            org.galaxy.client.service.fragmentmanagement.ModelFragmentData[] impactes,
            java.lang.Integer modelfragmentId,
            java.lang.String name,
            java.lang.String version) {
        setDependencies(dependencies);
        setDescription(description);
        setGalaxyId(galaxyId);
        setImpactes(impactes);
        setModelfragmentId(modelfragmentId);
        setName(name);
        setVersion(version);
    }



    public void addRessourceFile(File resFile, String path) {   
        this.resFiles.add( new RessourceFile(resFile, path));
    }


    public void addDependency(ModelFragmentData fragment){
        ModelFragmentData[] dependencies  = this.getDependencies();
       
        int length = 0;
        
        if (dependencies != null){
            length = dependencies.length;
        }
        
        ModelFragmentData[] newDependencies = new ModelFragmentData[length + 1];
        
        for (int i = 0;  i < length; i++ ){
            newDependencies[i] = dependencies[i];
        }
        
        newDependencies[length] = fragment;
        
        this.setDependencies(newDependencies);
    }
    
    public void addDependency(String name, String version){
        ModelFragmentData data = new ModelFragmentData();
        data.setName(name);
        data.setVersion(version);
        addDependency(data);
    }

    public void addProprietaryFile(File propFile, String path, String vendor, String format) {
        this.propFiles.add( new ProprietaryFile(propFile, path, vendor, format));
    }
    
    public List<ProprietaryFile> getProprietaryFiles(){
        return this.propFiles;
    }
    
    public List<RessourceFile> getRessourceFiles(){
        return this.resFiles;
    }


    public File getXmiFile() {
        return this.xmiFile;
    }

    public void setXmiFile(File xmiFile) {
        this.xmiFile = xmiFile;
    }  

}
