package org.galaxy.client.service.rolemanagement;

public class RoleManagementProxy implements org.galaxy.client.service.rolemanagement.RoleManagement {
  private String _endpoint = null;
  private org.galaxy.client.service.rolemanagement.RoleManagement roleManagement = null;
  
  public RoleManagementProxy() {
    _initRoleManagementProxy();
  }
  
  public RoleManagementProxy(String endpoint) {
    _endpoint = endpoint;
    _initRoleManagementProxy();
  }
  
  private void _initRoleManagementProxy() {
    try {
      roleManagement = (new org.galaxy.client.service.rolemanagement.RoleManagementServiceLocator()).getRoleManagementPort();
      if (roleManagement != null) {
        if (_endpoint != null)
          ((javax.xml.rpc.Stub)roleManagement)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
        else
          _endpoint = (String)((javax.xml.rpc.Stub)roleManagement)._getProperty("javax.xml.rpc.service.endpoint.address");
      }
      
    }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  
  public String getEndpoint() {
    return _endpoint;
  }
  
  public void setEndpoint(String endpoint) {
    _endpoint = endpoint;
    if (roleManagement != null)
      ((javax.xml.rpc.Stub)roleManagement)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    
  }
  
  public org.galaxy.client.service.rolemanagement.RoleManagement getRoleManagement() {
    if (roleManagement == null)
      _initRoleManagementProxy();
    return roleManagement;
  }
  
  public java.lang.Integer createRole(org.galaxy.client.service.rolemanagement.Role role) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (roleManagement == null)
      _initRoleManagementProxy();
    return roleManagement.createRole(role);
  }
  
  public void deleteRole(java.lang.Integer roleId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (roleManagement == null)
      _initRoleManagementProxy();
    roleManagement.deleteRole(roleId);
  }
  
  public void deleteRoles(int[] roleIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (roleManagement == null)
      _initRoleManagementProxy();
    roleManagement.deleteRoles(roleIds);
  }
  
  public org.galaxy.client.service.rolemanagement.Role[] findAllRoles() throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (roleManagement == null)
      _initRoleManagementProxy();
    return roleManagement.findAllRoles();
  }
  
  public org.galaxy.client.service.rolemanagement.Role findRoleById(java.lang.Integer roleId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (roleManagement == null)
      _initRoleManagementProxy();
    return roleManagement.findRoleById(roleId);
  }
  
  public org.galaxy.client.service.rolemanagement.Role[] findRoleByIds(int[] roleIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (roleManagement == null)
      _initRoleManagementProxy();
    return roleManagement.findRoleByIds(roleIds);
  }
  
  public org.galaxy.client.service.rolemanagement.Role[] findRolesByProject(java.lang.Integer projectId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (roleManagement == null)
      _initRoleManagementProxy();
    return roleManagement.findRolesByProject(projectId);
  }
  
  public org.galaxy.client.service.rolemanagement.Role[] findRolesByProjectAndParticipant(java.lang.Integer projectId, java.lang.Integer participantId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (roleManagement == null)
      _initRoleManagementProxy();
    return roleManagement.findRolesByProjectAndParticipant(projectId, participantId);
  }
  
  public void updateRole(org.galaxy.client.service.rolemanagement.Role role) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (roleManagement == null)
      _initRoleManagementProxy();
    roleManagement.updateRole(role);
  }
  
  
}