package org.galaxy.client.service.usermanagement;

public class UserManagementProxy implements org.galaxy.client.service.usermanagement.UserManagement {
  private String _endpoint = null;
  private org.galaxy.client.service.usermanagement.UserManagement userManagement = null;
  
  public UserManagementProxy() {
    _initUserManagementProxy();
  }
  
  public UserManagementProxy(String endpoint) {
    _endpoint = endpoint;
    _initUserManagementProxy();
  }
  
  private void _initUserManagementProxy() {
    try {
      userManagement = (new org.galaxy.client.service.usermanagement.UserManagementServiceLocator()).getUserManagementPort();
      if (userManagement != null) {
        if (_endpoint != null)
          ((javax.xml.rpc.Stub)userManagement)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
        else
          _endpoint = (String)((javax.xml.rpc.Stub)userManagement)._getProperty("javax.xml.rpc.service.endpoint.address");
      }
      
    }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  
  public String getEndpoint() {
    return _endpoint;
  }
  
  public void setEndpoint(String endpoint) {
    _endpoint = endpoint;
    if (userManagement != null)
      ((javax.xml.rpc.Stub)userManagement)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    
  }
  
  public org.galaxy.client.service.usermanagement.UserManagement getUserManagement() {
    if (userManagement == null)
      _initUserManagementProxy();
    return userManagement;
  }
  
  public java.lang.Integer createParticipant(org.galaxy.client.service.usermanagement.Participant participant) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (userManagement == null)
      _initUserManagementProxy();
    return userManagement.createParticipant(participant);
  }
  
  public void deleteParticipant(java.lang.Integer participantId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (userManagement == null)
      _initUserManagementProxy();
    userManagement.deleteParticipant(participantId);
  }
  
  public void deleteParticipants(int[] participantIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (userManagement == null)
      _initUserManagementProxy();
    userManagement.deleteParticipants(participantIds);
  }
  
  public org.galaxy.client.service.usermanagement.Participant[] findAllParticipants() throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (userManagement == null)
      _initUserManagementProxy();
    return userManagement.findAllParticipants();
  }
  
  public org.galaxy.client.service.usermanagement.Participant findParticipantById(java.lang.Integer participantId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (userManagement == null)
      _initUserManagementProxy();
    return userManagement.findParticipantById(participantId);
  }
  
  public org.galaxy.client.service.usermanagement.Participant[] findParticipantsByIds(int[] participantIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (userManagement == null)
      _initUserManagementProxy();
    return userManagement.findParticipantsByIds(participantIds);
  }
  
  public org.galaxy.client.service.usermanagement.Participant[] findParticipantsByProject(java.lang.Integer projectId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (userManagement == null)
      _initUserManagementProxy();
    return userManagement.findParticipantsByProject(projectId);
  }
  
  public org.galaxy.client.service.usermanagement.Participant[] findParticipantsByProjectAndRoles(java.lang.Integer projectId, int[] roleIds) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (userManagement == null)
      _initUserManagementProxy();
    return userManagement.findParticipantsByProjectAndRoles(projectId, roleIds);
  }
  
  public org.galaxy.client.service.usermanagement.Participant[] findParticipantsByWorkgroup(java.lang.Integer workgroupId) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (userManagement == null)
      _initUserManagementProxy();
    return userManagement.findParticipantsByWorkgroup(workgroupId);
  }
  
  public void updateParticipant(org.galaxy.client.service.usermanagement.Participant participant) throws java.rmi.RemoteException, org.galaxy.client.service.IOException{
    if (userManagement == null)
      _initUserManagementProxy();
    userManagement.updateParticipant(participant);
  }
  
  
}