package org.galaxy.client.test;
import java.io.File;
import java.io.IOException;
import java.util.zip.ZipException;

import org.galaxy.client.api.GalaxyService;
import org.galaxy.client.api.IProjectManagement;
import org.galaxy.client.api.IRoleManagement;
import org.galaxy.client.api.IUserManagement;
import org.galaxy.client.api.IWorkgroupManagement;
import org.galaxy.client.service.fragmentmanagement.ressource.ModelFragmentRessource;
import org.galaxy.client.service.projectmanagement.Project;
import org.galaxy.client.service.rolemanagement.Role;
import org.galaxy.client.service.usermanagement.Participant;
import org.galaxy.client.service.workgroupmanagement.Workgroup;



public class InterfaceTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
	
		String endpoint ="http://194.2.241.224:8080/GalaxyServer-Galaxy/";
		GalaxyService service = new GalaxyService(endpoint);
		
		        
		IRoleManagement prole = service.getRoleManagement();
        IWorkgroupManagement pwork = service.getWorkgroupManagement();
        IUserManagement puser = service.getUserManagement();
        IProjectManagement pproject = service.getProjectManagement();
        
        
        ModelFragmentRessource fragmentTest = new ModelFragmentRessource();
        File outputDir = new File("C:\\Temp");
        try {
            File packagedFrag = service.getModelFragmentManagement().packageFragment(fragmentTest, outputDir);
            service.getModelFragmentManagement().publish(packagedFrag);
        } catch (ZipException e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
        } catch (IOException e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
        }
		
        
       

		try {
			
			Role role = new Role();
			role.setName("R1");
			role.setDescription("R1D");
			
			Integer roleId = prole.createRole(role);

			Role r1 = prole.findRoleById(roleId);
			
			System.out.println("------ Role 1 ------");
			System.out.println(r1.getName());
			System.out.println(r1.getDescription());
			System.out.println(r1.getCategory());
			System.out.println("");
			
			r1.setCategory("R1C");
			prole.updateRole(r1);
			
			System.out.println("------ Role 2 ------");
			for(Role r2 : prole.findAllRoles()){
				System.out.println(r2.getId() + " " + r2.getName() + " " +r2.getDescription() + " " +r2.getCategory());
			}
			System.out.println("");
				
			Role role2 = new Role();
			role2.setName("R2");
			role2.setDescription("R2D");
			role.setCategory("R2C");
				
			Integer roleId2 = prole.createRole(role2);
			
			System.out.println("------ Role 3 ------");
			for(Role r3 : prole.findRoleByIds(new int[]{roleId,roleId2} )){	
				System.out.println(r3.getId() + " " + r3.getName() + " " +r3.getDescription() + " " +r3.getCategory());			
			}
			System.out.println("");
			
			Workgroup w1 = new Workgroup();
			w1.setName("W1");

			Integer workgroupId1 = pwork.createWorkgroup(w1);
			
			w1.setId(workgroupId1);
			w1.setDescription("W1D");
			pwork.updateWorkgroup(w1);
			
			Workgroup w2 = pwork.findWorkgroupById(workgroupId1);
			System.out.println("------ Workgroup 1 ------");
			System.out.println(w2.getId());
			System.out.println(w2.getName());
			System.out.println("");
			
			System.out.println("------ Workgroup 2 ------");
			for(Workgroup w3 : pwork.findAllWorkgroups()){
				System.out.println(w3.getId() + " " + w3.getName() + " " +w3.getDescription());	
			}
			System.out.println("");
			
			Workgroup w3 = new Workgroup();
			w3.setName("W2");
			w3.setDescription("W2D");
			
			Integer workgroupId2 =  pwork.createWorkgroup(w3);
			
			System.out.println("------ Workgroup 3 ------");
			for(Workgroup w4 : pwork.findWorkgroupsByIds(new int[]{workgroupId1,workgroupId2})){
				System.out.println(w4.getId() + " " + w4.getName() + " " +w4.getDescription());	
			}
			System.out.println("");
			
			Participant user = new Participant();
			user.setFirstName("U1F");
			
			Integer unserId = puser.createParticipant(user);
			
			Participant u1 = puser.findParticipantById(unserId);
			System.out.println("------ Paricipant 1 ------");
			System.out.println(u1.getId());
			System.out.println(u1.getFirstName());
			System.out.println(u1.getLastName());
			System.out.println("");
			
			u1.setLastName("U1L");
			puser.updateParticipant(u1);
			
			System.out.println("------ Paricipant 2 ------");
			for(Participant u2 : puser.findAllParticipants()){
				System.out.println(u2.getId() + " " + u2.getFirstName() + " " + u2.getLastName());
			}
			System.out.println("");
			
			Participant u3 = new Participant();
			u3.setFirstName("U2F");
			
			Integer unserId2 = puser.createParticipant(u3);
			
			System.out.println("------ Paricipant 3 ------");
			for(Participant u4 : puser.findParticipantsByIds(new int[]{unserId,unserId2})){
				System.out.println(u4.getId() + " " + u4.getFirstName() + " " + u4.getLastName());
			}
			System.out.println("");
			
			Project project = new Project();
			project.setName("P1");
			
			Integer projectId = pproject.createProject(project);
				
			Project p1 = pproject.findProjectById(projectId);
			
			System.out.println("------ Project 1 ------");
			System.out.println(p1.getId());
			System.out.println(p1.getName());
			System.out.println(p1.getDescription());
			System.out.println("");
			
			p1.setDescription("P1D");
			
			pproject.updateProject(p1);
				
			System.out.println("------ Project 2 ------");
			for(Project p2 : pproject.findAllProjects()){
				System.out.println(p2.getId() + " " + p2.getName() + " " + p2.getDescription());
			}
			System.out.println("");
			
			Project p3 = new Project();
			p3.setName("P3");
			
			Integer projectId2 = pproject.createProject(p3);
			
			System.out.println("------ Project 3 ------");
			for(Project p4 : pproject.findProjectByIds(new int[]{projectId,projectId2})){
				System.out.println( p4.getId() + " " +  p4.getName() + " " +  p4.getDescription());
			}
			System.out.println("");
			
			
			
			pproject.addRole(projectId, roleId);
			System.out.println("------ Role - Project ------");
			for(Role r5 : prole.findRolesByProject(projectId)){
				System.out.println(r5.getName());
			}
			
			
			
			
			pproject.removeRole(projectId, roleId);
			
			pproject.addRoles(projectId, new int[] {roleId,roleId2});
			
			System.out.println("------ Role - Project (2) ------");
			for(Role r : prole.findRolesByProject(projectId)){
				System.out.println(r.getName());
			}
			
			
			
			pproject.addParticipant(projectId, unserId2, new int[]{roleId,roleId2});
			
			
			System.out.println("------ Project / Participant - Role------");
			for(Role r : prole.findRolesByProjectAndParticipant(projectId, unserId2)){
				System.out.println(r.getName());
			}
			
			
			System.out.println("------ Project - participant------");
			for(Participant p : puser.findParticipantsByProject(projectId)){
				System.out.println(p.getFirstName());
			}
			
			pproject.removeParticipant(projectId, unserId2,new int[]{roleId,roleId2});
			
			pproject.addParticipants(projectId,  new int[]{unserId}, new int[]{roleId});
			pproject.addParticipants(projectId,  new int[]{unserId2}, new int[]{roleId2});
			
			System.out.println("------ Project - participant (role)------");
			for(Participant p : puser.findParticipantsByProjectAndRoles(projectId, new int[]{roleId})){
				System.out.println(p.getFirstName());
			}
				
			System.out.println("------ Participant - Project ------");
			for(Project p : pproject.findProjectsByParticipant(unserId)){	
				System.out.println(p.getName());
			}
			
			
			pproject.removeParticipants(projectId, new int[]{unserId,unserId2}, new int[]{roleId,roleId2});

			pwork.addParticipant(workgroupId1, unserId);
			
			
			System.out.println("------ Participant  - Workgroup  ------");	
			for(Workgroup w : pwork.findWorkgroupsByParticipant(unserId)){
				System.out.println(w.getName());
			}
			
			pwork.removeParticipant(workgroupId1, unserId);	
			pwork.addParticipants(workgroupId1, new int[]{unserId2});
			
			System.out.println("------ Workgroup - Participant ------");
			for(Participant p : puser.findParticipantsByWorkgroup(workgroupId1)){	
				System.out.println(p.getFirstName());
			}
			
			pwork.removeParticipants(workgroupId1, new int[]{unserId,unserId2});		
			pproject.removeRoles(projectId2,  new int[] {roleId,roleId2});

			for(Participant u : puser.findAllParticipants()){
				puser.deleteParticipant(u.getId());
			}
			
			for(Project p : pproject.findAllProjects()){
				pproject.deleteProject(p.getId());
			}
			
			for(Workgroup w : pwork.findAllWorkgroups()){
				pwork.deleteWorkgroup(w .getId());
			}
			
			for(Role r : prole.findAllRoles()){
				prole.deleteRole(r.getId());
			}
			
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}

}
