package org.galaxy.model;

import java.io.Serializable;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.Table;

/**
 * Object-relational persistence model dedicated to Workgroup
 */
@Entity
@Table(name = "Workgroup")
public class EWorkgroup implements Serializable{

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Integer workgroupId;

	private String name;
	
	private String description;
	
	
	
	@ManyToMany(cascade=CascadeType.REMOVE)
	@JoinTable(name = "WORKGROUP_PARTICIPANT",
	joinColumns = {
			@JoinColumn(name="FK_WORKGROUPID") 
	},
	inverseJoinColumns = {
			@JoinColumn(name="FK_PARTICIPANTID")
	}
	)
	private List<EParticipant> participants;

	@ManyToMany(cascade=CascadeType.REMOVE)
	@JoinTable(name = "WORKGROUP_FRAGMENT",
	joinColumns = {
	@JoinColumn(name="FK_WORKGROUPID") 
	},
	inverseJoinColumns = {
	@JoinColumn(name="GK_GALAXYID")})
	private List<EModelFragment> fragments;
	
	public EWorkgroup(){
		
	}
	
	public List<EParticipant> getParticipants() {
		return participants;
	}
	
	public void setParticipants(List<EParticipant> participants) {
		this.participants = participants;
	}
	
	
	public List<EModelFragment> getFragments() {
		return fragments;
	}
	
	public void setFragments(List<EModelFragment> fragments) {
		this.fragments = fragments;
	}

	
	public Integer getWorkgroupId() {
		return workgroupId;
	}
	
	public void setWorkgroupId(Integer workgroupId) {
		this.workgroupId = workgroupId;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public String getDescription() {
		return description;
	}
	
	public void setDescription(String description) {
		this.description = description;
	}
	
	@Override
	public boolean equals(Object obj) {
		return (obj instanceof EWorkgroup) && ((EWorkgroup)obj).getWorkgroupId().equals(getWorkgroupId());
	}
}
