package org.galaxy.utility.filerepository;

import java.io.File;

/**
 * This interface contains services in order to manage physical ModelFragment repository into GalaxyServer.
 */
public interface IFileRepository {
	
	/**
	 * Deleting a file  contained in Model Fragments repository
	 * @param fragmentname Name of ModelFragment
	 * @param fragmentversion version of ModelFragment
	 * @throws IOFragmentException
	 */
	public void deleteFile(String fragmentname,String fragmentversion) throws IOFragmentException;	
	
	/**
	 * Calculates the path of the file on the repository from its name and version
	 * @param fragmentname Name of ModelFragment
	 * @param fragmentversion version of ModelFragment
	 * @return File path of ModelFragment file
	 */
	public String calculateLocalPath(String fragmentname,String fragmentversion);
	
	/**
	 * Storing a ModelFragment in the repository
	 * @param temporaryfile ModelFragment File
	 * @param fragmentname  Name of ModelFragment
	 * @param fragmentversion version of ModelFragment
	 * @throws IOFragmentException
	 */
	public void storeFile(File temporaryfile,String fragmentname, String fragmentversion) throws IOFragmentException;
	
	/**
	 * Retrieving a Model Fragment from the repository
	 * @param fragmentname Name of ModelFragment
	 * @param fragmentversion version of ModelFragment
	 * @return ModelFragment File
	 * @throws IOFragmentException
	 */
	public String retiveFile(String fragmentname,String fragmentversion)throws IOFragmentException;

}
