<?php

class RoleController extends Zend_Controller_Action {
	var $role_serivce;
	public function init() {
		require_once (dirname ( __FILE__ ) . '/services/RoleManagement.php');
		
		$options = $this->getInvokeArg('bootstrap')->getOptions();
		$serverpath = $options['galaxy']['serverpath'];

		$this->role_service = new RoleManagement ( $serverpath );
	}
	
	public function indexAction() {
		$this->view->roles = $this->role_service->findAllRoles ();
	}
	
	public function createAction() {
		$form = new Application_Form_Role ();
		$form->createContent ( true );
		$form->submit->setLabel ( 'Create Role' );
		$this->view->form = $form;
		
		if ($this->getRequest ()->isPost ()) {
			$formData = $this->getRequest ()->getPost ();
			if ($form->isValid ( $formData )) {
				$name = $form->getValue ( 'name' );
				$description = $form->getValue ( 'description' );
				$category = $form->getValue ( 'category' );
				
				$this->role_service->createRole ( $name, $description, $category );
				
				$this->_helper->redirector ( 'index' );
			} else {
				$this->view->error = ' * Champs requis.';
			}
		}
	
	}
	
	public function editAction() {
		$form = new Application_Form_Role ();
		$form->createContent ( true );
		$form->submit->setLabel ( 'Save Changes' );
		$this->view->form = $form;
		
		if ($this->getRequest ()->isPost ()) {
			$formData = $this->getRequest ()->getPost ();
			if ($form->isValid ( $formData )) {
				
				$id = ( int ) $form->getValue ( 'id' );
				$name = $form->getValue ( 'name' );
				$description = $form->getValue ( 'description' );
				$category = $form->getValue ( 'category' );
				$this->role_service->updateRole ( $id, $name, $description, $category );
				
				$this->_helper->redirector ( 'index' );
			} else {
				$this->view->error = ' * Champs requis.';
			}
		} else {
			
			$id = $this->_getParam ( 'id', 0 );
			$name = $this->_getParam ( 'name', "0" );
			$description = $this->_getParam ( 'description', "" );
			$category = $this->_getParam ( 'category', "" );
			
			$form->populate ( array (
					'id' => $id,
					'name' => $name,
					'description' => $description,
					'category' => $category 
			) );
		}
	}
	
	public function deleteAction() {
		if ($this->getRequest ()->isPost ()) {
			$del = $this->getRequest ()->getPost ( 'del' );
			if ($del == 'Yes') {
				$id = $this->getRequest ()->getPost ( 'id' );
				
				$this->role_service->deleteRole ( $id );
			
			}
			
			$this->_helper->redirector ( 'index' );
		} else {
			$id = $this->_getParam ( 'id', 0 );
			$name = $this->_getParam ( 'name', "0" );
			$this->view->account = array (
					"id" => $id,
					"name" => $name 
			);
		}
	}
}

