<?php

class WorkgroupManagement {
	protected $client;
	
	function __construct($server) {
		$sbWsdl = $server. '/WorkgroupManagement?wsdl';
		$this->client = new SoapClient ( $sbWsdl );
	}
	
	public function findAllWorkgroups() {
		$param = array ();
		$response = $this->client->__soapCall ( "findAllWorkgroups", $param );
		return $this->objectToArray ( $response );
	}
	
	public function createWorkgroup($name, $description) {
		$param = array (
				array (
						workgroup => array (
								"name" => $name,
								"description" => $description,
								"id" => "" 
						) 
				) 
		);
		return $this->client->__soapCall ( "createWorkgroup", $param );
	}
	
	public function updateWorkgroup($id, $name, $description) {
		$param = array (
				array (
						workgroup => array (
								"name" => $name,
								"description" => $description,
								"id" => $id 
						) 
				) 
		);
		return $this->client->__soapCall ( "updateWorkgroup", $param );
	}
	
	public function deleteWorkgroup($id) {
		$param = array (
				array (
						"workgroupId" => $id 
				) 
		);
		return $this->client->__soapCall ( "deleteWorkgroup", $param );
	}
	
	public function addParticipant($workgroupId, $participantId) {
		$param = array (
				'addParticipant' => array (
						"workgroupId" => $workgroupId,
						"participantId" => $participantId 
				) 
		);
		return $this->client->__soapCall ( "addParticipant", $param );
	}
	
	public function removeParticipant($workgroupId, $participantId) {
		$param = array (
				'removeParticipant' => array (
						"workgroupId" => $workgroupId,
						"participantId" => $participantId 
				) 
		);
		return $this->client->__soapCall ( "removeParticipant", $param );
	}
	
	
	public function findWorkgroupsByParticipant($id) {
		$param = array (
				array (
						"participantId" => $id
				)
		);
		$response = $this->client->__soapCall ( "findWorkgroupsByParticipant", $param );
		return $this->objectToArray ( $response );
	}
	
	public function objectToArray($d) {
		
		if (is_object ( $d )) {
			// Gets the properties of the given object
			// with get_object_vars function
			$d = get_object_vars ( $d );
		}
		
		if (count ( $d ) > 0) {
			foreach ( $d as $val ) {
				if (is_array ( $val )) {
					return $val;
				}
			
			}
			return $d;
		}
	}
}
?>